#
#  Data analysis and introduction
#  to R programmation Application R
#  Yeganeh Forouheshfar
#
#  sujet: Les bases
#------------------------------



# LOAD PACKAGES ############################################

# I recommend "pacman" for managing add-on packages. It will
# install packages, if needed, and then load the packages.
install.packages("pacman")


# Then load the package by using either of the following:
require(pacman)  # Gives a confirmation message.
library(pacman)  # No message.

# Or, by using "pacman::p_load" you can use the p_load
# function from pacman without actually loading pacman.
# These are packages I load every time.
pacman::p_load(pacman, dplyr, GGally, ggplot2, ggthemes, 
               ggvis, httr, lubridate, plotly, rio, rmarkdown, shiny, 
               stringr, tidyr) 

library(datasets)  # Load/unload base packages manually



# COLON OPERATOR ###########################################
(x0 <- 1.2)


# Assigns number 0 through 10 to x1

x1 <- 0:10
x1

# Descending order, parentices shows results in the console
(x2 <- 10:0)


0:20 -> x3
x3

# SEQ ######################################################

?seq  # R help on seq
help(seq) # Another alternative to ask for help


# Ascending values (duplicates 1:10)

(x4 <- seq(10))

# Specify change in values
(x5 <- seq(30, 0, by = -3))


# ENTER MULTIPLE VALUES WITH C #############################

# c = concatenate (or combine or collect)
?c  # R help on c

x6 <- c(5, 4, 1, 6, 7, 2, 2, 3, 2, 8)
x6



# REP ######################################################

?rep  # R help on rep
x7 <- rep(TRUE, 5)
x7 <- rep(T, 5)
x7


# Repeats set
x8 <- rep(c(TRUE, FALSE), 5)
x8

# Repeats items in set
x9 <- rep(c(TRUE, FALSE), each = 5)
x9



# DATA TYPES ###############################################

# Numeric


x0
typeof(x0)


typeof(x1)


# Character

x10 <- "g"
typeof(x10)

x11 <- c("Paris","London", "Berlin")
x11
typeof(x11)



# Logical


typeof(x7)



# DATA STRUCTURES ##########################################

## Vector ##################################################

v1 <- c(1, 2, 3, 4, 5)
v1
is.vector(v1)

v2 <- c("a", "b", "c")
v2
x12 <- is.vector(v2)
typeof(x12)


v3 <- c(TRUE, TRUE, FALSE, FALSE, TRUE)
v3
is.vector(v3)



## Matrix ##################################################
?matrix
m1 <- matrix(c(T, T, F, F, T, F), nrow = 2)
m1

m2 <- matrix(c("a", "b",
               "c", "d"), 
             nrow = 2,
             byrow = T)
m2



## Array ###################################################

# Give data, then dimemensions (rows, columns, tables)
?array
a1 <- array(c( 1:24), c(4, 3, 2))
a1

## Data frame ##############################################

# Can combine vectors of the same length

vNumeric   <- c(1, 2, 3)
vCharacter <- c("a", "b", "c")
vLogical   <- c(T, F, T)

dfa <- cbind(vNumeric, vCharacter, vLogical)
dfa  # Matrix of one data type

df <- as.data.frame(cbind(vNumeric, vCharacter, vLogical))
df  # Makes a data frame with three different data types

## List ####################################################

o1 <- c(1, 2, 3)
o2 <- c("a", "b", "c", "d")
o3 <- c(T, F, T, T, F)

list1 <- list(o1, o2, o3)
list1

list2 <- list(o1, o2, o3, list1)  # Lists within lists!
list2

#### Suprimer un objet
rm(list1)


# CLEAN UP #################################################

# Clear packages
p_unload(dplyr, tidyr, stringr) # Clear specific packages
detach("package:datasets", unload = TRUE)  # For base

p_unload(all)  # Easier: clears all add-ons




# Clear environment
rm(list = ls()) 

# Clear console
cat("\014")  # ctrl+L


