#
#  Cours Introduction à l'économétrie: Application R
#  Yeganeh Forouheshfar
#
#  sujet: Excercise : de l'importation .... regression
#------------------------------



library(datasets)  # Load base packages manually

# Installs pacman ("package manager") if needed
if (!require("pacman")) install.packages("pacman")


# Use pacman to load add-on packages as desired
pacman::p_load(pacman, caret, lars, tidyverse, rio, psych, 
               GGally,arm,dplyr, huxtable, officer, flextable,
               jtools, plyr)
 


########## importation des données
infidelite <- import(file.choose())

####### Stat Des ####

describe(infidelite)
summary(infidelite)

###### Correlation matrix
c2 <- cor(infidelite$Y, infidelite$Z3)

(Cl <- cor(infidelite)) # correlation Matrix

# You need GGally package
?ggcorr
ggcorr(infidelite, method = c("pairwise", "pearson")) #to visualize correlation

ggcorr(infidelite, method = c("pairwise", "pearson"),
       nbreaks = NULL, digits = 3, low = "blue",
       mid = "white", high = "red",
       geom = "tile", label = T,
       label_alpha = F)


####### Some charts

#barchart (infidelite$Y,infidelite$Z1)
plot(infidelite) # not interesting

attach(infidelite)
plot(Z2,Y)  # age and infidelity, it does not look nice either


hist(infidelite$Y)

(Yfrequency <- table(Y))
barplot(Yfrequency)  # the bar chart does a better job than the histogram





####### the regression

summary(regA <- lm(Y ~ Z1 + Z2 + Z3 + Z4 + Z5 + Z6 + Z7 + Z8 ))


summary(regB <- lm(Y ~ Z1  + Z3 + Z4 + Z5 + Z7 + Z8 )) # to avoid multicollinearity

# nice regression table:
export_summs(regA, regB)

##### run a t-test to check weather women or men are more unfaithful 

t.test(Y ~ Z1)  # (mean(Y)for Z1=1 ) == (mean(Y)for Z1=0 )

t.test(Y ~ Z4)





detach(infidelite)


# CLEAN UP #################################################


# Clear plots
dev.off()  # But only if there IS a plot

# Clear environment
rm(list = ls()) 

# Clear packages
p_unload(all)  # Remove all add-ons

# Clear console
cat("\014")  # ctrl+L


